Subject: bug#64420: string-width of … is 2 in CJK environments

From: Yuan Fu <[email-masked]>
Date: Fri, 14 Jul 2023 13:11:21 -0700

> On Jul 14, 2023, at 4:04 AM, Eli Zaretskii <[email-masked]> wrote:
> 
>> From: SUNG TAE KIM <[email-masked]>
>> Date: Fri, 14 Jul 2023 18:21:42 +0900
>> Cc: [email-masked]
>> 
>> What I meant by default was default in the CJK language environment and the default width of the
>> ambiguous characters in CJK environment should be narrow. Current emacs changes the width of
>> ambiguous characters to wide if the user activates the CJK environment. The unicode standard
>> recommendation is set the width narrow at unclear circumstances but emacs changes the width to
>> wide even if it can't know what font is currently used. For that reason, I don't think such behavior is
>> aligned well with the unicode standard.
> 
> We don't blindly follow the Unicode Standard.  We seriously consider
> its recommendations, and then do whatever we think is best for our
> users.
> 
>> Furthermore, The majority of the default width of those
>> characters in the CJK environment is narrow on contemporary implementation of the terminals from
>> my limited experience. However, Considering the emacs package ecosystem, current emacs
>> behavior is ok as long as there's an easy option for changing such values.
> 
> It is not yet clear to me whether handling these characters as narrow
> by default in CJK language-environments is TRT.  But adding an option
> to do so is a first step in that direction, if indeed this is the
> right direction: we can in the future make this optional behavior be
> the default, if we arrive at the conclusion that most users configure
> their fonts and their terminal emulators such that these characters
> have the narrow width.

I tend to agree with Sung Tae, but this sounds like a reasonable compromise to me.

Yuan